EDIT - bug #6220

Improve definition of orphaned taxon and synonym
11/24/2016 01:32 PM - Andreas Muller

Status: Closed Start date:

Priority: New Due date:

Assignee: Katja Luther % Done: 80%
Category: cdmlib Estimated time: 0:00 hour
Target version: Release 4.4

Severity: normal Found in Version: Release 4.3
Description

Currently taxa are only orphaned if they have no taxon node AND no concept relationships. The later is critical as taxa with concept
relationships may still be handled as orphaned except for misapplied names (a concept relationship that is more synonym
relationship like). Later also pro parte and partial synonym relationships may be added to this list.

Also synonyms were unclear when they are orphaned. They should be orphaned if not belonging to an accepted taxon or if the
accepted taxon is orphaned.

Related issues:
Copied from EDIT - feature request #5616: Add the"Open in..." menu to taxon s... Closed

Associated revisions

Revision 0ec16ff8 - 05/25/2016 05:28 PM - Patrick Plitzner
Implement isOrphaned() #5824

Synonym counts as orphaned if all of the accepted taxa are orphaned

Revision 147686 - 10/12/2016 09:00 PM - Andreas Miuller

ref #5974 Remove synonym relationship first compiling implementation in cdmlib

Revision 4b80789a - 11/24/2016 01:33 PM - Andreas Miiller

fix #6220 Improve isOrphaned definition for Taxon.

Revision c6c4ab3a - 11/24/2016 01:44 PM - Andreas Miiller
ref #6220 javadoc

History

#1 - 11/24/2016 01:35 PM - Andreas Miller
- Parent task set to #5616

#2 - 11/24/2016 01:35 PM - Andreas Miiller
- Status changed from New to Resolved

- % Done changed from 0 to 50

Applied in changeset cdmlib|4b80789a6d183956c922de22091164555d2ef442.

#3 - 11/24/2016 02:21 PM - Andreas Miiller
- Status changed from Resolved to Feedback
- Assignee changed from Andreas Miiller to Katja Luther

- % Done changed from 50 to 80

The fix works so far that search result in TaxEditor allow only opening in TaxEditor now. However, an orphaned taxon as described in #5616 still
shows the wrong symbol (black for accepted).
Is there also another algorithm that determines orphaned in the search results?

Also orphaned synonyms are not found in TaxEditor taxon bulk editor anymore.
Katja, can you have a look on this? If necessary create a new ticket.
#4 - 11/25/2016 11:44 AM - Katja Luther
Andreas Milller wrote:
The fix works so far that search result in TaxEditor allow only opening in TaxEditor now. However, an orphaned taxon as described in #5616 still

shows the wrong symbol (black for accepted).
Is there also another algorithm that determines orphaned in the search results?

The editor uses the uuidAndTitleCache object and for a misapplied name the orphaned flag is set to false, so the used image is the one for a not
orphaned taxon -> black square.

Also orphaned synonyms are not found in TaxEditor taxon bulk editor anymore.
There is a problem with partial and proparte. If there is no values for these attibutes, an exception is thrown because a boolean attribute can not be
null.

If | replace NULL with 0 then all synonyms and taxa are found. We need to add this to the update script, if it is not included already.

Katja, can you have a look on this? If necessary create a new ticket.

#5 - 11/25/2016 11:55 AM - Andreas Miiller

Katja Luther wrote:
Andreas Muller wrote:
The fix works so far that search result in TaxEditor allow only opening in TaxEditor now. However, an orphaned taxon as described in

#5616 still shows the wrong symbol (black for accepted).
Is there also another algorithm that determines orphaned in the search results?

The editor uses the uuidAndTitleCache object and for a misapplied name the orphaned flag is set to false, so the used image is the one for a not
orphaned taxon -> black square.

But it is NOT a misapplied name as far as | remember but only has concept relations. Therefore the "Open in" works correctly now.
#6 - 11/25/2016 12:01 PM - Andreas Miiller
Katja Luther wrote:
Andreas Miiller wrote:
Also orphaned synonyms are not found in TaxEditor taxon bulk editor anymore.
There is a problem with partial and proparte. If there is no values for these attibutes, an exception is thrown because a boolean attribute can not

be null.
If | replace NULL with 0 then all synonyms and taxa are found. We need to add this to the update script, if it is not included already.

This should already be fixed in the update script. However, the test server was updated before this fix. | thought | did update all test server databases
manually. If not, please let me know where you found this problem. Definitely it is not on the example database | mentioned above
(cdm_rem_conf_am). | tested with
SELECT *
FROM TaxonBase
WHERE DTYPE = 'Synonym' AND (proParte IS NULL OR partial IS NULL)
Also, if this is the problem, the exception should be thrown (and shown to the user) and not be swallowed by the system.
#7 - 11/25/2016 01:15 PM - Katja Luther
Andreas Miller wrote:
Katja Luther wrote:

Andreas Mller wrote:

The fix works so far that search result in TaxEditor allow only opening in TaxEditor now. However, an orphaned taxon as described in
#5616 still shows the wrong symbol (black for accepted).
Is there also another algorithm that determines orphaned in the search results?

The editor uses the uuidAndTitleCache object and for a misapplied name the orphaned flag is set to false, so the used image is the one for
a not orphaned taxon -> black square.

But it is NOT a misapplied name as far as | remember but only has concept relations. Therefore the "Open in" works correctly now.

The open in works correctly now. The wrong symbol for taxa with conceptrelationships/misapplied names is because the orphaned flag is set by the
hgl query not by the isOrphaned() method.

#8 - 11/25/2016 03:35 PM - Andreas Miiller

Katja Luther wrote:

The open in works correctly now. The wrong symbol for taxa with conceptrelationships/misapplied names is because the orphaned flag is set by
the hgl query not by the isOrphaned() method.

This is what | expected. So the critical question is here, how we can keep the java based definition of "isOrphaned” in sync with any hql based
methods. Or should we simply leave a warning in the according javadoc that some hql also needs to be adapted.
Also exact tests may help for both methods.

#9 - 11/25/2016 03:40 PM - Katja Luther

Andreas Muller wrote:
Katja Luther wrote:

The open in works correctly now. The wrong symbol for taxa with conceptrelationships/misapplied names is because the orphaned flag is
set by the hql query not by the isOrphaned() method.

This is what | expected. So the critical question is here, how we can keep the java based definition of "isOrphaned” in sync with any hql based
methods. Or should we simply leave a warning in the according javadoc that some hql also needs to be adapted.
Also exact tests may help for both methods.

| found this http://stackoverflow.com/questions/25382840/loading-transient-field-of-jpa-entity
| tried to add a transient attribute isOrphaned and add a method which should be called after loading the entity (with PostLoad annotation).
But the first test did not work. But | think this could be a solution to keep it in sync.

#10 - 12/01/2016 04:34 PM - Andreas Miiller

Katja Luther wrote:
Andreas Miiller wrote:
Katja Luther wrote:
The open in works correctly now. The wrong symbol for taxa with conceptrelationships/misapplied names is because the orphaned flag

is set by the hgl query not by the isOrphaned() method.

This is what | expected. So the critical question is here, how we can keep the java based definition of "isOrphaned” in sync with any hql
based methods. Or should we simply leave a warning in the according javadoc that some hql also needs to be adapted.
Also exact tests may help for both methods.

| found this http://stackoverflow.com/questions/25382840/loading-transient-field-of-jpa-entity,
| tried to add a transient attribute isOrphaned and add a method which should be called after loading the entity (with PostLoad annotation).
But the first test did not work. But | think this could be a solution to keep it in sync.

This might be a solution but not very nice as it runs the check whenever a taxon is loaded so the performance is going down. We may think about
caching this data. Once cache updating works better this might be a solution to keep it more or less in sync and also to retrieve the data directly from
database which makes some queries faster (e.g. if you don't want to show orphaned taxa at all)

#11 - 05/18/2018 12:01 PM - Patrick Plitzner
- Parent task deleted (#5616)
#12 - 05/18/2018 12:01 PM - Patrick Plitzner

- Target version changed from Release 4.4 to Release 5.1
moving to current milestone while closing #5616

#13 - 05/18/2018 12:02 PM - Patrick Plitzner

- Copied from feature request #5616: Add the"Open in..." menu to taxon search added

#14 - 05/18/2018 12:13 PM - Andreas Miiller

- Target version changed from Release 5.1 to Release 4.4

| don't understand why you moved this to the current milestone. The ticket is mostly fixed. The open issues are more about how to guarantee that
thinks stay in sync in future which is a minor part of this ticket. We may want to move these open issues to a new ticket.

#15 - 05/30/2018 10:29 AM - Andreas Miiller

Katja, can you please extract the open issues to a new ticket and close this one?

#16 - 11/03/2021 02:19 PM - Katja Luther
- Status changed from Feedback to Closed

Andreas Muller wrote:

Katja, can you please extract the open issues to a new ticket and close this one?

created a new ticket #9845 and close this one
